"
 COPYRIGHT (c) 1996 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"


NonVersioningSourceCodeManager subclass:#FlatDirectorySourceCodeManager
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'System-SourceCodeManagement'
!

!FlatDirectorySourceCodeManager class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

!

documentation
"
    FlatDirectorySourceCodeManager accesses sourcefiles from a single flat
    'source' directory, as delivered with the demo version.

    This one is not normally used with ST/X (you really should use
    CVS or some other version management)
    However, it shows how AbstractSourceCodeManager can be subclassed
    if private sourceCodeManagers are to be written.

    [test]
        for test/demo only, switch to a sourceCodeManager, which
        accesses all files directly from the 'source' directory:
            SourceCodeManager := FlatDirectorySourceCodeManager.


    [author:]
        Claus Gittinger

    [see also:]
        CVSSourceCodeManager
"

! !

!FlatDirectorySourceCodeManager class methodsFor:'source code access'!

streamForClass:aClass fileName:fileName revision:revision directory:packageDir module:moduleDir cache:cacheIt
    "extract a source file and return an open readStream on it,
     or nil if the extract failed. If revision is nil or (#newest), take
     the latest; otherwise, a specific revisions source is extracted.
     The cls argument is currently ignored, but may be used in future versions,
     to validate the correct container against the class."

    |f p revisionStringInFile info cls|

    cls := aClass.
    cls isMeta ifTrue:[
        cls := aClass soleInstance
    ].

    SourceRoot isNil ifTrue:[
        f := Smalltalk getSourceFileName:fileName.
    ] ifFalse:[
        f := SourceRoot , '/' , fileName
    ].

    f notNil ifTrue:[
        (revision notNil
        and:[revision ~~ #newest]) ifTrue:[

            "/ validate - at least a bit of added secutiry

            p := PipeStream readingFrom:('ident < ' , f asString).
            p notNil ifTrue:[
                revisionStringInFile := p nextLine.
                p close.
            ].
            revisionStringInFile notNil ifTrue:[
                info := Class revisionInfoFromString:revisionStringInFile.
            ].
            info notNil ifTrue:[
                (info at:#revision) ~= revision ifTrue:[
                    ('SourceCodeManager [warning]: sourceFile for ' , cls name , ' has rev. ' , (info at:#revision) , '; expected: ' , revision) infoPrintCR.
                ].
            ] ifFalse:[
                'SourceCodeManager [warning]: cannot validate revision of class' infoPrintCR.
            ].
        ].

        ^ f asFilename readStream.
    ].

    ^ nil

    "Modified: 14.2.1997 / 20:52:19 / cg"
! !

!FlatDirectorySourceCodeManager class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/Attic/FlatDirectorySourceCodeManager.st,v 1.3 1997-01-14 20:25:01 cg Exp $'
! !
